#set-env BAT_THEME Coldark-Cold
set-env BAT_PAGER 'less -RF'
set-env EDITOR vim
set-env VIEW 'vim -R'
set-env CURRENT_SHELL 'elvish'
set-env STARSHIP_CONFIG ~/.config/starship/starship.toml
set-env PERL5LIB /home/benjamin/perl5/lib/perl5
set @paths = $@paths /home/benjamin/bin /home/benjamin/Go/bin /home/benjamin/perl5/bin

{
  use framagit.org/benjamin.vaudour/elv-lib/mods/list
  if (list:contains-not /usr/local/bin $paths) {
    set @paths = $@paths /usr/local/bin
  }
}

set notify-bg-job-success = $false

set edit:insert:binding[Tab]    = { edit:completion:smart-start; edit:navigation:trigger-filter }
set edit:insert:binding[Ctrl-H] = $edit:histlist:start~

#set edit:prompt  = { go-prompt }
#set edit:rprompt = { nop }

# Starship prompt : https://starship.rs/
#eval (starship init elvish)
eval (starship init elvish --print-full-init | upgrade-scripts-for-0.17 -lambda | slurp)

# Carapace completion : https://github.com/rsteube/carapace-bin
eval (carapace _carapace|slurp)

# Initialisation des aliases et de l’autocomplétion
use framagit.org/benjamin.vaudour/elv-lib/alias
use framagit.org/benjamin.vaudour/elv-lib/completion

# On ajoute les modules natifs que j’utilise beaucoup
use math
use str
use re
#use framagit.org/benjamin.vaudour/elv-lib/mods/format
#use framagit.org/benjamin.vaudour/elv-lib/mods/list
#use framagit.org/benjamin.vaudour/elv-lib/mods/map

{
  use ./aliases/get-uid uid
  if (not (uid:-is-root)) {
    tache search -d 2w not del
  }
}
